from src.helpers import TimeTracking
import logging
import time


class run(object):
    """
    basic run class to measure execution time. Either call this class calling it by 'with' or delete the class instance
    after finishing the measurement. The duration result is logged.
    """

    def __init__(self):
        self.time = TimeTracking()
        logging.info(f"{self.__class__.__name__} started")

    def __del__(self):
        self.time.stop()
        logging.info(f"{self.__class__.__name__} finished after {self.time}")

    def __enter__(self):
        pass

    def __exit__(self, exc_type, exc_val, exc_tb):
        pass

    def do_stuff(self):
        time.sleep(2)


class PreProcessing(run):

    def __init__(self, setup):
        super().__init__()
        self.setup = setup


class Training(run):

    def __init__(self, setup):
        super().__init__()
        self.setup = setup


class PostProcessing(run):

    def __init__(self, setup):
        super().__init__()
        self.setup = setup
